
// https://developer.mozilla.org/en/Code_snippets/On_page_load#Running_code_on_an_extension%27s_first_run_or_after_an_extension%27s_update
var SkipScreenOverlay = {
    init: function(){

	var prev = -1, firstrun = true;
	var skipdate = ""; var dateNotSet = true;
	var showFirsts = true, debugVerbose = false;

	// no need for this var to be in the global name-space
	// NOR to share a potentiall common name. so, ssPrefs
	var svc = Components.classes["@mozilla.org/preferences-service;1"]
	.getService(Components.interfaces.nsIPrefService);
	var ssPrefs = svc.getBranch("extensions.skipscreen.");

	//gets the version number.
	var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
	.getService(Components.interfaces.nsIExtensionManager);
	var current = gExtensionManager.getItemForID("SkipScreen@SkipScreen").version;

	try{

	    prev = ssPrefs.getCharPref("version");
	    firstrun = ssPrefs.getBoolPref("firstrun");
	    skipdate = ssPrefs.getCharPref("firstskipdate");
	    dateNotSet = (skipdate == "");
	    showFirsts = ssPrefs.getBoolPref("showfirstruns"); // allows start pages to be turned off for partners
	    debugVerbose = ssPrefs.getBoolPref("debugVerbose");

	}catch(e){

	    alert("SkipScreen error in auxilliary.js: " + e.message
		  + "\n\ncurrent: " + current
		  + "\nprev: " + prev
		  + "\nfirstrun: " + firstrun
		  + "\nskipdate: " + skipdate
		  + "\nshowFirstRuns: " + showFirsts
		  + "\ndebugVerbose: " + debugVerbose);

	}finally{

	    // debugVerbose s/b set to false for AMO and self-builds
	    // leave as manually set for beta-builds
	    if (debugVerbose) {
		alert("current: " + current
		      + "\nprev: " + prev
		      + "\nfirstrun: " + firstrun
		      + "\nshowFirstRuns: " + showFirsts
		      + "\ndebugVerbose: " + debugVerbose
		      + "\nskipdate: " + skipdate );
	    }

	    if (dateNotSet) {
		ssPrefs.setCharPref("firstskipdate", Date());
	    }

	    // change this depending on the branch
	    var newPage = "http://www.skipscreen.com/install/whatsnew_beta.html?ver=" + current;

	    // NOTE: showfirst-check is INSIDE both code-blocks, because prefs need to be set no matter what.
	    if (firstrun){
		ssPrefs.setBoolPref("firstrun",false);
		ssPrefs.setCharPref("version",current);

		if (showFirsts) {
		    // Insert code for first run here
		    window.setTimeout(function(){
			gBrowser.selectedTab = gBrowser.addTab("http://www.skipscreen.com/welcome.html");
			gBrowser.selectedTab = gBrowser.addTab(newPage);
		    }, 1500); //Firefox 2 fix - or else tab will get closed (leave it in....)
		}

	    }

	    if (prev!=current && !firstrun){ // !firstrun ensures that this section does not get loaded if its a first run.
		ssPrefs.setCharPref("version",current);

		if (showFirsts) {
		    // version is different => upgrade (or conceivably downgrade)
		    window.setTimeout(function(){
			gBrowser.selectedTab = gBrowser.addTab(newPage + '&prev=' + prev);
		    }, 1500); //Firefox 2 fix - or else tab will get closed
		}
	    }
	} // end finally

	window.removeEventListener("load",function(){ SkipScreenOverlay.init(); },true);
    },


    optionMenu: function () {
	try{
	    skipWin = window.openDialog('chrome://skipscreen/content/options.xul', 'SkipScreen Options', 'chrome,titlebar,toolbar,centerscreen,resizable');
	    skipWin.focus();
	} catch (e) {
	    alert(e);
	}
	return true;
    },

    aboutMenu: function () {
	try{
	    skipWin = window.openDialog('chrome://skipscreen/content/about.xul', 'SkipScreen About', 'chrome,titlebar,toolbar,centerscreen,resizable');
	    skipWin.focus();
	} catch (e) {
	    alert(e);
	}
	return true;
    }


};

// fires on browser launch, which includes open-link-in-new-window
window.addEventListener("load",function(){ SkipScreenOverlay.init(); },true);
